
[1mNAME[m
	mdl - display DL animations in monochrome ST

[1mSYNOPSIS[m
	[1mmdl[m  [m[[1m-v[m]  [m[[1m-h[m]  [m[[1m-s[m]  [m[[1m-z[m]  [m[[1m-r[m  [4mfps[m]  [m[[1m-b[m [4mbeta[m] [m[[1m-n[m [4mnoise[m] [m[[1m-i[m
	[4mintens[m] [m[[4mfile[m]

[1mDESCRIPTION[m
	[4mmdl[m reads a file in DL format and displays the animation in that
	file on a monochrome (only) Atari ST.  The DL file is read  from
	either the  standard  input  or the specified [4mfile[m.  The program
	runs on monochrome 640 by 400 displays [4monly[m.

	Once  the  program  starts,  it  should  NOT  be  killed with ^C
	(because  there  is  no  signal  handler  to  catch ^C and reset
	screens).  After  the  animation  starts, any key will cause the
	program to exit.

[1mOPTIONS[m
	The following command line options are recognized:

	[1m-v[m	Verbose.  Print progress info to stdout  while  building
		the images.

	[1m-h[m	Print help info and exit.

	[1m-s[m	Single (dithered)  image.    Do  not  set  up  the three
		"flicker" images for each frame.  Speeds  up  setup  but
		not playback.

	[1m-z[m	If the animation is in medium format (160 x 100) it will
		be zoomed up to large format (320 x 200).  If the anima-
		tion is in large format this switch will be ignored.

	[1m-r [4mfps[m
		Determines  the  rate  of  the animation, i.e., how many
		frames per second that should be displayed.  The minimum
		is 1 and the default is 25.  The maximum  on  an  ST  is
		probably about 100.

	[1m-b [4mbeta[m
		Apply a  Laplace  filter to the image.  Tends to sharpen
		up the image.  Values for [4mbeta[m start at 0 and  increase.
		A  value  of  0  means  do not apply the filter (same as
		omitting the [1m-b[m switch).  A value of 4 is usually good.

	[1m-n [4mnoise[m
		Add an amount of random noise to the images.   Tends  to
		help some flickered images.  Values for [4mnoise[m range from
		0 to 255.    A value of 0 means no noise.  A value of 10
		is usually good.

	[1m-i [4mintens[m
		Increase (or decrease) the intensity of every  pixel  by
		this amount.   [4mintens[m  range from -255 to 255.  Adjusted
		values will be bounded by 0 and 255.

[1mEXAMPLES[m
	Most DL files I have seen run best between 8 and 15  frames  per
	second.  [4mmdl[m is fairly accurate in the frame rate (though it was
	only clocked at 1 fps).

	Display the animation foo.dl at 25 frames per second.

		mdl foo.dl

	Display  the  animation  fie.dl,  zoomed  to large format, at 12
	frames per second.

		mdl -z -r 12 fie.dl

[1mBUGS[m
	None that I have found.  However, the program is a one day hack:
	it uses [4mSetscreen[m(2x) to rapidly  switch  between  images.    It
	probably  won't run on a color system (without hacking the color
	palette) and it won't run on any display  that  is  not  640  by
	400.  You get what you pay for!

	The  program  has had limited testing (only a few .dl files were
	available) with only version 2 medium format files.

	Report  bugs  to  rosenkra@convex.com.  The other  authors won't
	know what you are talking about.

[1mAUTHOR[m
	Bill Rosenkranz <rosenkra@convex.com> using flicker code from my
	MGIF  program  (which  was  based  on  code  by  Klaus  Pedersen
	<micro@imada.dk>).

	Jonas Yngvesson <jonas-y@isy.liu.se> for the X Windows xdl.

	The   program   is   derived  from  dltogl  by  George  Phillips
	<phillips@cs.ubc.ca>

	The suggestion (and code) to allow the user to set the animation
	rate (in xdl) came from Per Beremark <per.beremark@telelogic.se>

