.TH MDL 1
.SH NAME
mdl \- display DL animations in monochrome ST
.SH SYNOPSIS
.B mdl
.RB [ \-v ]
.RB [ \-h ]
.RB [ \-s ]
.RB [ \-z ]
.RB [ \-r
.IR fps ]
.RB [ \-b
.IR beta ]
.RB [ \-n
.IR noise ]
.RB [ \-i
.IR intens ]
.RI [ file ]
.SH DESCRIPTION
.I mdl
reads a file in DL format and displays the animation in that file
on a monochrome (only) Atari ST.
The DL file is read from either the standard input or the
specified
.IR file .
The program runs on monochrome 640 by 400 displays
.IR only .
.PP
Once the program starts, it should NOT be killed with ^C
(because there is no signal handler to catch ^C and reset screens).
After the animation starts, any key will cause the program to exit.
.SH OPTIONS
The following command line options are recognized:
.IP \fB\-v\fR
Verbose.
Print progress info to stdout while building the images.
.IP \fB\-h\fR
Print help info and exit.
.IP \fB\-s\fR
Single (dithered) image.
Do not set up the three "flicker" images for each frame.
Speeds up setup but not playback.
.IP \fB\-z\fR
If the animation is in medium format (160 x 100) it will be zoomed
up to large format (320 x 200).
If the animation is in large format this switch will be ignored.
.IP "\fB\-r \fIfps\fR"
Determines the rate of the animation, i.e., how many frames per second
that should be displayed.
The minimum is 1 and the default is 25.
The maximum on an ST is probably about 100.
.IP "\fB\-b \fIbeta\fR"
Apply a Laplace filter to the image.
Tends to sharpen up the image.
Values for
.I beta
start at 0 and increase.
A value of 0 means do not apply the filter (same as omitting the
.B \-b
switch).
A value of 4 is usually good.
.IP "\fB\-n \fInoise\fR"
Add an amount of random noise to the images.
Tends to help some flickered images.
Values for
.I noise
range from 0 to 255.
A value of 0 means no noise.
A value of 10 is usually good.
.IP "\fB\-i \fIintens\fR"
Increase (or decrease) the intensity of every pixel by this amount.
.I intens
range from -255 to 255.
Adjusted values will be bounded by 0 and 255.
.SH EXAMPLES
Most DL files I have seen run best between 8 and 15 frames per second.
.I mdl
is fairly accurate in the frame rate (though it was only clocked at 1 fps).
.PP
Display the animation foo.dl at 25 frames per second.
.IP
mdl foo.dl
.PP
Display the animation fie.dl, zoomed to large format, at 12 frames
per second.
.IP
mdl -z -r 12 fie.dl
.SH BUGS
None that I have found.
However, the program is a one day hack:
it uses
.IR Setscreen (2x)
to rapidly switch between images.
It probably won't run on a color system (without hacking the color
palette) and it won't run on any display that is not 640 by 400.
You get what you pay for!
.PP
The program has had limited testing (only a few .dl files were available)
with only version 2 medium format files.
.PP
Report bugs to rosenkra@convex.com.
The other authors won't know what you are talking about.
.SH AUTHOR
Bill Rosenkranz <rosenkra@convex.com> using flicker code from my MGIF
program (which was based on code by Klaus Pedersen <micro@imada.dk>).
.PP
Jonas Yngvesson <jonas-y@isy.liu.se> for the X Windows xdl.
.PP
The program is derived from dltogl by George Phillips <phillips@cs.ubc.ca>
.PP
The suggestion (and code) to allow the user to set the animation
rate (in xdl) came from Per Beremark <per.beremark@telelogic.se>
